Index: cpp/gdk/3d.cpp
===================================================================
--- cpp/gdk/3d.cpp	(revision 45)
+++ cpp/gdk/3d.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include <math.h>
Index: cpp/gdk/3d.h
===================================================================
--- cpp/gdk/3d.h	(revision 45)
+++ cpp/gdk/3d.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _3D_H_
Index: cpp/gdk/advlist.cpp
===================================================================
--- cpp/gdk/advlist.cpp	(revision 45)
+++ cpp/gdk/advlist.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include <stdlib.h>
Index: cpp/gdk/advlist.h
===================================================================
--- cpp/gdk/advlist.h	(revision 45)
+++ cpp/gdk/advlist.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _ADVLIST_H_
Index: cpp/gdk/callbacks.cpp
===================================================================
--- cpp/gdk/callbacks.cpp	(revision 45)
+++ cpp/gdk/callbacks.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "callbacks.h"
Index: cpp/gdk/callbacks.h
===================================================================
--- cpp/gdk/callbacks.h	(revision 45)
+++ cpp/gdk/callbacks.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _CALLBACKS_H_
Index: cpp/gdk/conv_f1.cpp
===================================================================
--- cpp/gdk/conv_f1.cpp	(revision 45)
+++ cpp/gdk/conv_f1.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "conv_f1.h"
@@ -48,6 +48,6 @@
 void addOrRememberInput(int n1,int n2,float w)
 		{
-		if (!addInput(n1,n2,w,false))
-			connections+=Connection(n1,n2,w);
+		//if (!addInput(n1,n2,w,false))
+		connections+=Connection(n1,n2,w);
 		}
 bool addInput(int n1,int n2,float w,bool final)
@@ -270,17 +270,4 @@
 }
 
-// remove leading & trailing whitespaces
-static void trim(SString& s)
-{
-const char*b=(const char*)s;
-const char*e=b+s.len();
-while((b<e)&&(*b<=' ')) b++;
-while((b<e)&&(e[-1]<=' ')) e--;
-if ((e-b)==s.len()) return;
-char* t=s.directWrite();
-if (t!=b) memmove(t,b,e-b);
-s.endWrite(e-b);
-}
-
 const char* Builder::growNeuro(const char* t, F1Props& props,int &hasmuscles)
 {
@@ -346,5 +333,5 @@
 				haveclass=1;
 				SString clsname(begin,t-begin);
-				trim(clsname);
+				clsname=trim(clsname);
 				last_f1_neuro->setClassName(clsname);
 				NeuroClass *cls=last_f1_neuro->getClass();
Index: cpp/gdk/conv_f1.h
===================================================================
--- cpp/gdk/conv_f1.h	(revision 45)
+++ cpp/gdk/conv_f1.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _CONV_F1_H
@@ -64,8 +64,7 @@
 GenoConv_F1()
 	{
-	name="f1 converter";
+	name="Recursive encoding";
 	in_format='1';
 	mapsupport=1;
-	info="Original Framsticks genotype format";
 	}
 SString convert(SString &i,MultiMap *map);
Index: cpp/gdk/convtest.cpp
===================================================================
--- cpp/gdk/convtest.cpp	(revision 45)
+++ cpp/gdk/convtest.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include <ctype.h>
Index: cpp/gdk/defassign-f0_joint.h
===================================================================
--- cpp/gdk/defassign-f0_joint.h	(revision 45)
+++ cpp/gdk/defassign-f0_joint.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 
Index: cpp/gdk/defassign-f0_neuro.h
===================================================================
--- cpp/gdk/defassign-f0_neuro.h	(revision 45)
+++ cpp/gdk/defassign-f0_neuro.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 
Index: cpp/gdk/defassign-f0_neuroconn.h
===================================================================
--- cpp/gdk/defassign-f0_neuroconn.h	(revision 45)
+++ cpp/gdk/defassign-f0_neuroconn.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 
Index: cpp/gdk/defassign-f0_part.h
===================================================================
--- cpp/gdk/defassign-f0_part.h	(revision 45)
+++ cpp/gdk/defassign-f0_part.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 
Index: cpp/gdk/defgenoconv.cpp
===================================================================
--- cpp/gdk/defgenoconv.cpp	(revision 45)
+++ cpp/gdk/defgenoconv.cpp	(revision 64)
@@ -1,6 +1,2 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
-
 #include "defgenoconv.h"
 
@@ -32,5 +28,5 @@
 #endif
 #ifdef USE_GENCONV_F81
-#include "conv_f8.h"
+#include "conv_f8tof1.h"
 #endif
 
@@ -62,5 +58,7 @@
 #endif
 #ifdef USE_GENCONV_F81
-addConverter(new GenoConv_F81);
+GenoConv_F8ToF1 *gc81=new GenoConv_F8ToF1();
+GenoConv_F8ToF1::staticpar=gc81->par; //a trick so that the simulator can see this parama
+addConverter(gc81);
 #endif
 
Index: cpp/gdk/defgenoconv.h
===================================================================
--- cpp/gdk/defgenoconv.h	(revision 45)
+++ cpp/gdk/defgenoconv.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _DEFGENOCONV_H_
Index: cpp/gdk/errmanager.cpp
===================================================================
--- cpp/gdk/errmanager.cpp	(revision 45)
+++ cpp/gdk/errmanager.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "errmanager.h"
@@ -90,4 +90,5 @@
 {
 if (w>maxlevel) maxlevel=w;
+if (w>=FMLV_INFO) infocount++;
 if (w>=FMLV_WARN) warncount++;
 if (w>=FMLV_ERROR) errcount++;
Index: cpp/gdk/errmanager.h
===================================================================
--- cpp/gdk/errmanager.h	(revision 45)
+++ cpp/gdk/errmanager.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _ERRMANAGER_H_
@@ -64,10 +64,10 @@
 {
   protected:
-int maxlevel,errcount,warncount,storlevel,storcount;
+int maxlevel,errcount,warncount,storlevel,storcount,infocount;
 SString msgs;
 
   public:
 
-void reset() {maxlevel=FMLV_INFO-1; errcount=warncount=storcount=0; msgs=0;}
+void reset() {maxlevel=FMLV_INFO-1; errcount=warncount=storcount=infocount=0; msgs=0;}
 
 enum Options2
@@ -76,4 +76,5 @@
 int getErrorCount()       {return errcount;}
 int getWarningCount()     {return warncount;}
+int getInfoCount()        {return infocount;}
 int getStoredCount()      {return storcount;}
 int getErrorLevel()       {return maxlevel;}
Index: cpp/gdk/extvalue.cpp
===================================================================
--- cpp/gdk/extvalue.cpp	(revision 45)
+++ cpp/gdk/extvalue.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "extvalue.h"
@@ -20,5 +20,6 @@
 	SString tmp("<");
 	tmp+=p->getName();
-	sprintf(tmp.directAppend(30)," object at %p>",object);
+	sprintf(tmp.directAppend(30)," object at %p>",
+		(object?object:paraminterface));
 	tmp.endAppend();
 	return tmp;
@@ -36,4 +37,5 @@
 	case TDouble: setd(src.ddata()); break;
 	case TObj: seto(src.odata()); break;
+	case TInvalid: type=TInvalid; break;
 	}
 }
@@ -284,4 +286,6 @@
 	case TObj:
 		return odata().toString();
+	case TInvalid:
+		return SString("undefined");
 	default:
 		return SString("null");
Index: cpp/gdk/extvalue.h
===================================================================
--- cpp/gdk/extvalue.h	(revision 45)
+++ cpp/gdk/extvalue.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _EXTVALUE_H_
@@ -13,5 +13,5 @@
 
 enum ExtPType
-{TUnknown=0,TInt,TDouble,TString,TObj};
+{TUnknown=0,TInt,TDouble,TString,TObj,TInvalid};
 
 /**
@@ -114,4 +114,5 @@
 	:type(TUnknown) {set(src);}
 void setEmpty();
+void setInvalid() {setEmpty();type=TInvalid;}
 ExtPType getType() {return type;}
 void *getObjectTarget(const char* classname) {return (type==TObj)?getObject().getTarget(classname):0;}
Index: cpp/gdk/f0-modeldef.m4
===================================================================
--- cpp/gdk/f0-modeldef.m4	(revision 45)
+++ cpp/gdk/f0-modeldef.m4	(revision 64)
@@ -6,5 +6,5 @@
 define(`AtSecondPart',`8')
 define(`InTheMiddle',`12')
-define(`MuscleClass',`16')
+define(`EffectorClass',`16')
 define(`ReceptorClass',`32')
 define(`V1BendMuscle',`64')
Index: cpp/gdk/f0.def
===================================================================
--- cpp/gdk/f0.def	(revision 45)
+++ cpp/gdk/f0.def	(revision 64)
@@ -66,4 +66,5 @@
 PROP(getInputNeuroIndex,0,1+2,`get input neuron index',p d(d),,,,p_getInputNeuroIndex,PROCEDURE)
 PROP(getInputWeight,0,1+2,`get input weight',p f(d),,,,p_getInputWeight,PROCEDURE)
+PROP(classObject,0,1+2,`neuron class',o NeuroClass,,,,classObject,GETONLY)
 ENDCLASS
 
@@ -100,4 +101,5 @@
 VISUALHINTS(ReceptorClass)
 SYMBOL(`2,7,100,50,90,50,90,40,70,40,80,50,70,60,90,60,90,50,11,75,50,65,50,60,55,55,45,50,55,45,45,40,50,35,50,30,45,25,50,30,55,35,50')
+NEUROPROP(r,1,0,Range,f,0.0,1.0,1.0,range)
 ENDNEUROCLASS
 
@@ -109,9 +111,9 @@
 NEUROCLASS(Const,*,Constant,Constant value,0,1,0)
 VISUALHINTS(Invisible)
-SYMBOL(`3,6,100,50,90,50,90,40,70,40,70,60,90,60,90,50,1,85,50,75,50,1,80,45,80,55')
+SYMBOL(`4,4,26,27,26,73,73,73,73,27,26,27,1,73,50,100,50,1,56,68,46,68,2,41,47,51,32,51,68')
 ENDNEUROCLASS
 
 NEUROCLASS(BendMuscle,|,Bend muscle,,1,0,2)
-VISUALHINTS(DontShowClass+MuscleClass+V1BendMuscle+AtFirstPart)
+VISUALHINTS(DontShowClass+EffectorClass+V1BendMuscle+AtFirstPart)
 SYMBOL(`6,5,25,40,35,40,45,50,35,60,25,60,25,40,4,65,85,65,50,75,50,75,85,65,85,3,65,56,49,29,57,24,72,50,4,68,53,70,53,70,55,68,55,68,53,5,50,21,60,15,70,14,79,15,87,20,81,10,1,86,20,77,21')
 NEUROPROP(p,0,0,power,f,0.01,1.0,0.25,power)
@@ -120,5 +122,5 @@
 
 NEUROCLASS(RotMuscle,@,Rotation muscle,,1,0,2)
-VISUALHINTS(DontShowClass+MuscleClass+V1RotMuscle+AtFirstPart)
+VISUALHINTS(DontShowClass+EffectorClass+V1RotMuscle+AtFirstPart)
 SYMBOL(`5,5,25,40,35,40,45,50,35,60,25,60,25,40,4,65,85,65,50,75,50,75,85,65,85,1,69,10,77,17,10,59,15,57,17,57,22,60,26,69,27,78,26,82,21,82,16,79,12,69,10,80,6,3,65,50,65,20,75,20,75,50')
 NEUROPROP(p,0,0,power,f,0.01,1.0,1.0,power)
@@ -126,7 +128,8 @@
 
 NEUROCLASS(Diff,D,Differentiate,Calculate the difference between the current and previous input value. Multiple inputs are aggregated with respect to their weights,-1,1,0)
+SYMBOL(`3,3,25,0,25,100,75,50,25,0,1,75,50,100,50,3,44,42,51,57,36,57,44,42')
 ENDNEUROCLASS
 
-NEUROCLASS(FuzzyNeuro,Fuzzy,Fuzzy system [EXPERIMENTAL!],Refer to publications to learn about this neuron,-1,1,0)
+NEUROCLASS(FuzzyNeuro,Fuzzy,Fuzzy system [EXPERIMENTAL!],Refer to publications to learn more about this neuron.,-1,1,0)
 SYMBOL(`5,2,30,65,37,37,44,65,3,37,65,44,37,51,37,58,65,2,51,65,58,37,65,65,6,100,50,70,50,70,25,25,10,25,90,70,75,70,50,1,70,65,25,65')
 NEUROPROP(ns,0,0,number of fuzzy sets,d,1,,,fuzzySetsNr)
@@ -136,10 +139,29 @@
 ENDNEUROCLASS
 
+NEUROCLASS(VectorEye,VEye,Vector Eye [EXPERIMENTAL!],Refer to publications to learn more about this neuron.,1,1,1)
+SYMBOL(`11,7,100,50,90,50,90,40,70,40,80,50,70,60,90,60,90,50,14,70,50,65,40,60,35,45,30,30,30,15,35,10,40,5,50,10,60,15,65,30,70,45,70,60,65,65,60,70,50,8,38,67,28,62,23,52,28,42,38,37,48,42,53,52,48,62,38,67,4,33,52,38,47,43,52,38,57,33,52,5,70,50,60,40,45,35,30,35,15,40,5,50,1,53,33,58,22,1,62,36,68,26,1,45,30,47,19,1,35,30,35,19,1,27,31,24,20,1,18,34,12,24')
+NEUROPROP(tx,0,0,target.x,f,,,,target.x)
+NEUROPROP(ty,0,0,target.y,f,,,,target.y)
+NEUROPROP(tz,0,0,target.z,f,,,,target.z)
+NEUROPROP(ts,0,0,target shape,s,0,-1,0,targetShape)
+NEUROPROP(p,0,0,perspective,f,0.1,10.0,1.0,perspz)
+NEUROPROP(s,0,0,scale,f,0.1,100.0,1.0,perspscale)
+NEUROPROP(h,0,0,show hidden lines,d,0,1,0,showhidden)
+NEUROPROP(o,0,0,`output lines count (each line needs four channels)',d,0,99,0,outputcount)
+NEUROPROP(d,0,0,debug,d,0,1,0,showdebug)
+ENDNEUROCLASS
+
+NEUROCLASS(VisualMotorNeuron,VMotor,Visual-Motor Cortex [EXPERIMENTAL!],`Must be connected to the VEye and properly set up. Refer to publications to learn more about this neuron.',-1,1,0)
+NEUROPROP(noIF,0,0,number of basic features,d,,,,noIF)
+NEUROPROP(noDim,0,0,number of degrees of freedom,d,,,,noDim)
+NEUROPROP(params,0,0,parameters,s,,,,params)
+ENDNEUROCLASS 
+
 NEUROCLASS(Sticky,Sti,Sticky [EXPERIMENTAL!],,1,0,1)
-VISUALHINTS(ReceptorClass)
+VISUALHINTS(EffectorClass)
 ENDNEUROCLASS
 
 NEUROCLASS(LinearMuscle,LMu,Linear muscle [EXPERIMENTAL!],,1,0,2)
-VISUALHINTS(MuscleClass)
+VISUALHINTS(EffectorClass)
 NEUROPROP(p,0,0,power,f,0.01,1.0,1.0,power)
 ENDNEUROCLASS
@@ -154,10 +176,13 @@
 
 NEUROCLASS(Channelize,Ch,Channelize,`Combines all input signals into a single multichannel output; Note: ChSel and ChMux are the only neurons which support multiple channels. Other neurons discard everything except the first channel.',-1,1,0)
+SYMBOL(`10,4,25,0,25,100,75,70,75,30,25,0,1,75,50,100,50,1,70,50,55,50,1,30,80,55,50,1,30,20,55,50,1,30,35,55,50,1,30,45,55,50,1,30,55,55,50,1,61,53,65,47,1,30,65,55,50')
 ENDNEUROCLASS
 
 NEUROCLASS(ChMux,ChMux,Channel multiplexer,`Outputs the selected channel from the second (multichannel) input. The first input is used as the selector value (-1=select first channel, .., 1=last channel)',2,1,0)
+SYMBOL(`7,4,25,0,25,100,75,70,75,30,25,0,1,75,50,100,50,1,70,50,55,50,3,50,55,55,50,50,45,50,55,3,30,67,45,67,45,50,50,50,1,35,70,39,64,2,30,33,53,33,53,48')
 ENDNEUROCLASS
 
 NEUROCLASS(ChSel,ChSel,Channel selector,`Outputs a single channel (selected by the \"ch\" parameter) from multichannel input',1,1,0)
+SYMBOL(`6,4,25,0,25,100,75,70,75,30,25,0,1,75,50,100,50,1,70,50,55,50,3,50,55,55,50,50,45,50,55,1,30,50,50,50,1,35,53,39,47')
 NEUROPROP(ch,0,0,channel,d,,,,ch)
 ENDNEUROCLASS
@@ -171,2 +196,3 @@
 NEUROPROP(t,0,0,time,f,0,6.283185307,0,t)
 ENDNEUROCLASS
+
Index: cpp/gdk/f0classes.h
===================================================================
--- cpp/gdk/f0classes.h	(revision 45)
+++ cpp/gdk/f0classes.h	(revision 64)
@@ -1,6 +1,2 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
-
 
 #define FIELDSTRUCT Part
@@ -100,5 +96,5 @@
 ParamEntry f0_neuro_paramtab[]=
 {
- {"Connections",3,9,"n" },
+ {"Connections",3,10,"n" },
  {"Other",},
  {"Visual",},
@@ -112,4 +108,5 @@
  {"getInputNeuroIndex",0,1+2,"get input neuron index","p d(d)",PROCEDURE(p_getInputNeuroIndex),},
  {"getInputWeight",0,1+2,"get input weight","p f(d)",PROCEDURE(p_getInputWeight),},
+ {"classObject",0,1+2,"neuron class","o NeuroClass",GETONLY(classObject),},
  {0,0,0,}
 };
@@ -159,2 +156,5 @@
 
 
+
+
+
Index: cpp/gdk/f0defxml.m4
===================================================================
--- cpp/gdk/f0defxml.m4	(revision 45)
+++ cpp/gdk/f0defxml.m4	(revision 64)
@@ -6,5 +6,5 @@
 define(`AtSecondPart',`8')
 define(`InTheMiddle',`12')
-define(`MuscleClass',`16')
+define(`EffectorClass',`16')
 define(`ReceptorClass',`32')
 define(`V1BendMuscle',`64')
Index: cpp/gdk/framsg.cpp
===================================================================
--- cpp/gdk/framsg.cpp	(revision 45)
+++ cpp/gdk/framsg.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "nonstd.h"
Index: cpp/gdk/framsg.h
===================================================================
--- cpp/gdk/framsg.h	(revision 45)
+++ cpp/gdk/framsg.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _FRAMSG_H_
Index: cpp/gdk/gdktest.cpp
===================================================================
--- cpp/gdk/gdktest.cpp	(revision 45)
+++ cpp/gdk/gdktest.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include <stdlib.h>
@@ -249,8 +249,19 @@
 }
 
+void findingConverters()
+{
+GenoConverter *gc=gcm.findConverters(0,'1');
+if (gc) printf("found converter accepting f1: \"%s\"\n",gc->name);
+SListTempl<GenoConverter*> found;
+gcm.findConverters(&found,-1,'0');
+printf("found %d converter(s) producing f0\n",found.size());
+}
+
 int main(int argc,char*argv[])
 {
 srand(time(0));
 printNiceBanner("Welcome to GDK test application!");
+
+findingConverters();
 
 //Geno g(argc>1?argv[1]:"X[|G:1.23]");
Index: cpp/gdk/gen-config.h
===================================================================
--- cpp/gdk/gen-config.h	(revision 45)
+++ cpp/gdk/gen-config.h	(revision 64)
@@ -1,8 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library. See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
-// This file is a part of Framsticks GDK library. See LICENSE.TXT for details.
-// Refer to http://www.frams.alife.pl/ for further information.
 
 /**
Index: cpp/gdk/geno.cpp
===================================================================
--- cpp/gdk/geno.cpp	(revision 45)
+++ cpp/gdk/geno.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "geno.h"
@@ -173,5 +173,8 @@
 	else
 		out+="/*";
-	out+=format;
+	if (format==0)
+		out+="invalid";
+	else
+		out+=format;
 	if (multiline)
 		out+="\n";
Index: cpp/gdk/geno.h
===================================================================
--- cpp/gdk/geno.h	(revision 45)
+++ cpp/gdk/geno.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _GENO_H_
Index: cpp/gdk/genoconv.cpp
===================================================================
--- cpp/gdk/genoconv.cpp	(revision 45)
+++ cpp/gdk/genoconv.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "nonstd.h"
@@ -49,4 +49,5 @@
 tab[0].flags=ile;
 tab[0].name="gkparam:";
+gcnames.clear();
 for (i=0,pe=tab+1;gk=(GenoConverter *)gcm->converters(i);pe++,i++)
 	{
@@ -54,5 +55,12 @@
 	pe->group=0;
 	pe->flags=0;
-	pe->name=gk->name;
+	std::string descr="f";
+	descr+=gk->in_format;
+	descr+=" -> f";
+	descr+=gk->out_format;
+	descr+=" : ";
+	descr+=gk->name;
+	gcnames.push_back(descr);
+	pe->name=descr.c_str();
 	pe->type="d 0 1";
 	pe->help=gk->info;
@@ -96,4 +104,20 @@
 converters-=gc;
 param.updatetab();
+}
+
+GenoConverter *GenoConvManager::findConverters(SListTempl<GenoConverter*>* result,char in,char out,int enabled,char* name)
+{
+GenoConverter *gk,*retval=0;
+int i=0;
+for (;gk=(GenoConverter*)converters(i);i++)
+	{
+	if ((in!=-1)&&(in!=gk->in_format)) continue;
+	if ((out!=-1)&&(out!=gk->out_format)) continue;
+	if ((enabled!=-1)&&(enabled!=gk->enabled)) continue;
+	if ((name)&&(strcmp(name,gk->name))) continue;
+	if (!retval) {retval=gk; if (!result) break;}
+	if (result) result->append(gk);
+	}
+return retval;
 }
 
Index: cpp/gdk/genoconv.h
===================================================================
--- cpp/gdk/genoconv.h	(revision 45)
+++ cpp/gdk/genoconv.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _GENCONV_H_
@@ -11,4 +11,7 @@
 #include "sstring.h"
 
+#include <string>
+#include <vector>
+
 
 class GenoConvManager;
@@ -17,4 +20,5 @@
 {
 GenoConvManager *gcm;
+std::vector<std::string> gcnames;
 void freetab();
 public:
@@ -89,4 +93,8 @@
 char *getPath(char in,char out,char *path,int maxlen,int *mapavailable=0);
 char *getFormatPath(char in,char out,char *path,int maxlen,int *mapavailable=0);
+/// returns the list of converters meeting the specified criteria
+/// pass result=0 if you only need one result (by return value)
+/// default criteria values mean "don't care", pass anything else to narrow your search
+GenoConverter *findConverters(SListTempl<GenoConverter*>* result=0,char in=-1,char out=-1,int enabled=-1,char* name=0);
 };
 
Index: cpp/gdk/genotest.cpp
===================================================================
--- cpp/gdk/genotest.cpp	(revision 45)
+++ cpp/gdk/genotest.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "geno.h"
Index: cpp/gdk/genotypeloader.cpp
===================================================================
--- cpp/gdk/genotypeloader.cpp	(revision 45)
+++ cpp/gdk/genotypeloader.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include "genotypeloader.h"
Index: cpp/gdk/genotypeloader.h
===================================================================
--- cpp/gdk/genotypeloader.h	(revision 45)
+++ cpp/gdk/genotypeloader.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _GENOTYPELOADER_H_
Index: cpp/gdk/list.cpp
===================================================================
--- cpp/gdk/list.cpp	(revision 45)
+++ cpp/gdk/list.cpp	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #include <stdlib.h>
Index: cpp/gdk/list.h
===================================================================
--- cpp/gdk/list.h	(revision 45)
+++ cpp/gdk/list.h	(revision 64)
@@ -1,5 +1,5 @@
-// This file is a part of Framsticks GDK library.
-// Copyright (C) 2002-2006  Szymon Ulatowski.  See LICENSE.txt for details.
-// Refer to http://www.frams.alife.pl/ for further information.
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
 
 #ifndef _LIST_H_
